#include<conio.h>		//getch()
#include<time.h>		//  ,  time()
#include<stdlib.h>		//srand, RAND_MAX, malloc, free
#include<iostream>		//cin, cout
using namespace std;

class matrix
{	private:         
		int xx,x;		//  ,  
		int yy,y;		//  ,  
		int **p;
	public:
		matrix(int,int);								// 
		matrix(matrix &);								// c .    
		matrix operator+(matrix);						//  
		friend matrix operator*(matrix, matrix);		//   
		~matrix();										// 
	    void show();	
};

matrix::matrix(int y1=3, int x1=3)			// 
{	yy=y1; xx=x1;
	p=new int*[yy];
	for (y=0;y<yy;y++) 
	{	p[y]=new int[xx];
		for (x=0;x<xx;x++)
			p[y][x]=rand()%3;		        // p[y][x]; <=> *(*(p+y)+x);			
	}
}
matrix::matrix(matrix &original)			//  
{	xx=original.xx;
	yy=original.yy;
	p=new int*[yy];
	for (y=0;y<yy;y++)
	{	p[y]=new int[xx];
		for (x=0;x<xx;x++)
			p[y][x]=original.p[y][x];			
	}
}
void matrix::show()							// 
{	for (y=0;y<yy;y++){
		for (x=0;x<xx;x++) 
			cout << p[y][x] << " ";		
      cout << '\n';
     }
}
matrix matrix::operator+(matrix v)			// 
{	if ((xx==v.xx)*(yy==v.yy)) 
	{	for (y=0;y<yy;y++)
			for (x=0;x<xx;x++)
				v.p[y][x]+=this->p[y][x];    // this -   ,    
		return v;
	}
	else { cout <<"Error\n"; return NULL; }
} 
matrix operator*(matrix u, matrix v)			// 
{	if (u.xx==v.yy)   	
	{	matrix res(u.yy,v.xx);
		for (u.y=0;u.y<u.yy;u.y++)
			for (u.x=0;u.x<v.xx;u.x++)
			{	res.p[u.y][u.x]=0;
				for (int z=0;z<u.xx;z++)
					res.p[u.y][u.x]+=u.p[u.y][z]*v.p[z][u.x];
			}
		return res;
	}
	else { cout <<"Error\n"; return NULL; }
}  
matrix::~matrix()								// 
{	for (int y=0;y<yy;y++)
		delete p[y];
	delete p;
}
void main()
{	srand(time(NULL));	
	int strB,colB;
	int strC,colC;
	cout << "Enter the number of rows and columns for the matrix B\n";
	cout << "Enter the number of rows and columns for the matrix C\n";
	cin >> strB >> colB;
	cin >> strC >> colC;		
	matrix A;
	A=A(5,5);								//    3*3
	matrix B(strB,colB), C(strC,colC);		 //  
	cout <<"\n\nMATRIX A\n\n";	    A.show();
	cout <<"\n\nMATRIX B\n\n";		B.show();
	cout <<"\n\nMATRIX C\n\n";		C.show();    
	cout <<"\n\nMATRIX B+C\n\n";    (B+C).show();
	cout <<"\n\nMATRIX B*C\n\n";    (B*C).show();
	getch();
}