#include<conio.h>		//getch()
#include<time.h>		//  ,  time()
#include<stdlib.h>		//srand, RAND_MAX, malloc, free
#include<iostream>		//cin, cout
using namespace std;

class complex
{	private:         
		float re,im;
		bool b;
	public:		
		complex(float,float);
		complex();
		complex operator+(complex);
		complex operator+(float);	
		complex operator-(complex);	
		friend complex operator*(complex, complex);
		friend complex operator/(complex, complex);		
	    void show();	
};
complex::complex()									// 
{	re=rand()%99;
	im=rand()%99;
	b=true;
}
complex::complex(float reCon, float imCon)			// 
{	re=reCon; im=imCon;
	b=true;
}
void complex::show()								// 
{	if (b) cout << "Re=" << re << " Im=" << im;
    else cout << "Error: /0";	
}
complex complex::operator+(complex C)				// 
{	C.re=re+C.re;
	C.im=im+C.im;
	return C;
}
complex complex::operator+(float A1)				// 
{	complex C;
	C.re=re+A1;
	C.im=im;//+C.im;
	return C;
}
complex complex::operator-(complex C)				// 
{	C.re=re-C.re;
	C.im=im-C.im;
	return C;
}
complex operator*(complex C1, complex C2)			// 
{	float bag=C1.re;
	C1.re=C1.re*C2.re-C1.im*C2.im;
	C1.im=bag*C2.im+C1.im*C2.re;
	return C1;
}
complex operator/(complex C1, complex C2)								// 
{	complex div;
	if((C2.re==0)*(C2.im==0)) div.b=false;
	div.re=(C1.re*C2.re+C1.im*C2.im)/(C2.re*C2.re+C2.im*C2.im);
	div.im=(C1.im*C2.re-C1.re*C2.im)/(C2.re*C2.re+C2.im*C2.im);
	return div;		
}

void main()
{	srand(time(NULL));	
	int re1,im1;
	int re2,im2;
	int A;
	cout << "Enter re1, im1, re2, im2, A\n";
	cin >> re1 >> im1;
	cin >> re2 >> im2;
	cin >> A;
	complex C1;								 
	complex C2(re1,im1),C3(re2,im2);		 
	cout << "\nComplex numbers:\n";
	cout <<"\nC1: ";	        C1.show();
	cout <<"\nC2: ";		C2.show();
	cout <<"\nC3: ";		C3.show();
	cout <<"\nA : "<<A;
	cout << "\n\nOperations:\n";
	cout <<"\nC2+C3: ";     (C2+C3).show();
	cout <<"\nC2+A : ";      (C2+A).show();
	cout <<"\nC2-C3: ";     (C2-C3).show();
	cout <<"\nC2*C3: ";     (C2*C3).show();
	cout <<"\nC2/C3: ";     (C2/C3).show();
	getch();
}